#ifndef __X10_UTIL_BUILDER_H
#define __X10_UTIL_BUILDER_H

#include <x10rt.h>


#define X10_LANG_ANY_H_NODEPS
#include <x10/lang/Any.h>
#undef X10_LANG_ANY_H_NODEPS
namespace x10 { namespace util { 

template<class TPMGL(Element), class TPMGL(Collection)> class Builder;
template <> class Builder<void, void>;
template<class TPMGL(Element), class TPMGL(Collection)> class Builder   {
    public:
    RTT_H_DECLS_INTERFACE
    
    template <class I> struct itable {
        itable(x10aux::ref<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> > (I::*add) (TPMGL(Element)), x10_boolean (I::*equals) (x10aux::ref<x10::lang::Any>), x10_int (I::*hashCode) (), TPMGL(Collection) (I::*result) (), x10aux::ref<x10::lang::String> (I::*toString) (), x10aux::ref<x10::lang::String> (I::*typeName) ()) : add(add), equals(equals), hashCode(hashCode), result(result), toString(toString), typeName(typeName) {}
        x10aux::ref<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> > (I::*add) (TPMGL(Element));
        x10_boolean (I::*equals) (x10aux::ref<x10::lang::Any>);
        x10_int (I::*hashCode) ();
        TPMGL(Collection) (I::*result) ();
        x10aux::ref<x10::lang::String> (I::*toString) ();
        x10aux::ref<x10::lang::String> (I::*typeName) ();
    };
    
    template <class R> static x10aux::ref<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> > add(x10aux::ref<R> _recv, TPMGL(Element) arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->add))(arg0);
    }
    template <class R> static x10aux::ref<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> > add(R _recv, TPMGL(Element) arg0) {
        return _recv->add(arg0);
    }
    template <class R> static x10_boolean equals(x10aux::ref<R> _recv, x10aux::ref<x10::lang::Any> arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->equals))(arg0);
    }
    template <class R> static x10_boolean equals(R _recv, x10aux::ref<x10::lang::Any> arg0) {
        return _recv->equals(arg0);
    }
    template <class R> static x10_int hashCode(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->hashCode))();
    }
    template <class R> static x10_int hashCode(R _recv) {
        return _recv->hashCode();
    }
    template <class R> static TPMGL(Collection) result(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->result))();
    }
    template <class R> static TPMGL(Collection) result(R _recv) {
        return _recv->result();
    }
    template <class R> static x10aux::ref<x10::lang::String> toString(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->toString))();
    }
    template <class R> static x10aux::ref<x10::lang::String> toString(R _recv) {
        return _recv->toString();
    }
    template <class R> static x10aux::ref<x10::lang::String> typeName(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Builder<TPMGL(Element), TPMGL(Collection)> >(_refRecv->_getITables())->typeName))();
    }
    template <class R> static x10aux::ref<x10::lang::String> typeName(R _recv) {
        return _recv->typeName();
    }
    
};
template <> class Builder<void, void> {
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_UTIL_BUILDER_H

namespace x10 { namespace util { 
template<class TPMGL(Element), class TPMGL(Collection)> class Builder;
} } 

#ifndef X10_UTIL_BUILDER_H_NODEPS
#define X10_UTIL_BUILDER_H_NODEPS
#include <x10/lang/Any.h>
#ifndef X10_UTIL_BUILDER_H_GENERICS
#define X10_UTIL_BUILDER_H_GENERICS
#endif // X10_UTIL_BUILDER_H_GENERICS
#ifndef X10_UTIL_BUILDER_H_IMPLEMENTATION
#define X10_UTIL_BUILDER_H_IMPLEMENTATION
#include <x10/util/Builder.h>

template<class TPMGL(Element), class TPMGL(Collection)> x10aux::RuntimeType x10::util::Builder<TPMGL(Element), TPMGL(Collection)>::rtt;
template<class TPMGL(Element), class TPMGL(Collection)> void x10::util::Builder<TPMGL(Element), TPMGL(Collection)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::util::Builder<void, void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[1] = { x10aux::getRTT<x10::lang::Any>()};
    const x10aux::RuntimeType* params[2] = { x10aux::getRTT<TPMGL(Element)>(), x10aux::getRTT<TPMGL(Collection)>()};
    x10aux::RuntimeType::Variance variances[2] = { x10aux::RuntimeType::invariant, x10aux::RuntimeType::invariant};
    const char *baseName = "x10.util.Builder";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::interface_kind, 1, parents, 2, params, variances);
}
#endif // X10_UTIL_BUILDER_H_IMPLEMENTATION
#endif // __X10_UTIL_BUILDER_H_NODEPS
